<script lang="ts">
import Vue from 'vue';
import { CarouselWrap } from '../../../common/index';
import CaseStudyQuote from './by-industry-case-study-quote.vue';
import { numberToDigitString } from '~/common/util';

export default Vue.extend({
  name: 'ByIndustryQuotesCarousel',
  components: { CarouselWrap, CaseStudyQuote },
  props: {
    data: {
      type: Object,
      required: true,
    },
  },
  data() {
    return {
      step: 0,
    };
  },
  computed: {
    formattedStep() {
      return `${numberToDigitString(this.step + 1)} - ${numberToDigitString(
        this.data.quotes.length,
      )}`;
    },
    singleQuote(): boolean {
      return this.data.quotes.length === 1;
    },
  },
  methods: {
    goNext() {
      this.$refs.carousel.next();
      this.step = this.step >= this.data.quotes.length - 1 ? 0 : this.step + 1;
    },
    goPrev() {
      this.$refs.carousel.prev();
      this.step = this.step <= 0 ? this.data.quotes.length - 1 : this.step - 1;
    },
  },
});
</script>

<template>
  <section
    class="quotes-carousel"
    :class="{
      'no-background': data.no_background,
    }"
  >
    <SlpContainer>
      <SlpRow>
        <div class="quotes-carousel__header">
          <SlpTypography v-if="data.header" tag="h2" variant="heading2-bold"
            ><span v-html="data.header"></span>
          </SlpTypography>
        </div>
        <CarouselWrap ref="carousel" :items="data.quotes">
          <template #content>
            <template v-if="$refs.carousel">
              <CaseStudyQuote
                v-for="quoteNumber in $refs.carousel.itemIndexes"
                :key="`quote-${quoteNumber}`"
                class="quotes-carousel__quote"
                :data="data.quotes[quoteNumber]"
                :data-ga-carousel="data.quotes[quoteNumber].ga_carousel"
              />
            </template>
          </template>
        </CarouselWrap>
        <div v-if="!singleQuote" class="quotes-carousel__footer">
          <SlpTypography tag="span" variant="body1" class="quote-count">{{
            formattedStep
          }}</SlpTypography>
          <div>
            <SlpButton
              variant="icon"
              aria-label="Prev"
              @click.native="goPrev()"
            >
              <SlpIcon
                name="chevron-lg-left"
                variant="product"
                hex-color="#171321"
              />
            </SlpButton>
            <SlpButton
              variant="icon"
              aria-label="Next"
              @click.native="goNext()"
            >
              <SlpIcon
                class="slp-ml-8"
                name="chevron-lg-right"
                variant="product"
                hex-color="#171321"
              />
            </SlpButton>
          </div>
        </div>
      </SlpRow>
    </SlpContainer>
  </section>
</template>

<style scoped lang="scss">
.quotes-carousel {
  padding: $spacing-96 0;
  position: relative;
  background: $color-surface-800;
  &:after {
    content: '';
    position: absolute;
    width: 200vw;
    height: 100%;
    top: 0;
    left: -50vw;
    z-index: -1;
    background: $color-surface-800;
  }

  &.no-background {
    background-color: transparent;
  }
  &.no-padding {
    padding: 0;
  }

  @media (max-width: $breakpoint-md) {
    padding: $spacing-48 0;
  }

  &__header {
    display: flex;
    width: 100%;
    flex-direction: column;
    padding-bottom: $spacing-32;
    border-bottom: 2px solid $color-surface-400;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
      align-items: center;
    }

    &:deep a {
      @media (max-width: $breakpoint-md) {
        padding-left: 0;
      }
    }
  }

  &__quote {
    display: inline-flex;
    margin-right: $spacing-16;
    flex: 0 0 100%;
    :deep .case-study-quote {
      margin-left: 0;
      justify-content: flex-start;
    }
  }

  &__footer {
    display: flex;
    width: 100%;
    align-items: center;
    padding: $spacing-16 0;
    .quote-count {
      margin-right: auto;
    }
  }
}
</style>
